/**
GCD using both a loop and recursion
**/

#include <iostream>
#include <string>
using namespace std;


// Euclid's non-recursive method for GCD:
long long gcdLoop(long long dividend, long long divisor)
{
    while(divisor != 0)
    {
        long long remainder = dividend % divisor;
        cout << "Dividend = " << dividend
             << ", divisor = " << divisor
             << ", remainder =" << remainder << endl;
        dividend = divisor;
        divisor = remainder;
    }

    return dividend;
}


// Tail Recursive GCD
long long gcdRec(const long long dividend, const long long divisor)
{
    long long remainder = dividend % divisor;
    cout << "Dividend = " << dividend
         << ", divisor = " << divisor
         << ", remainder =" << remainder << endl;
    if(remainder == 0)
        return divisor;
    else
        return gcdRec(divisor, remainder);
}


int main()
{
    cout << "gcdLoop: " << gcdLoop(24212,238) << endl << endl;
    cout << "gcdRec: " << gcdRec(24212,238) << endl << endl;

    return 0;
}
