// modified stack for tower of hanoi
#include "stack.h"

// This is the declaration for AStack.
// Array-based stack implementation
template <typename E>
class AStack: public Stack<E> {
private:

public:
  int maxSize;     // Maximum size of stack
  int topIndex;         // Index for top element
  E *listArray;    // Pointer to type E to hold array of stack elements

  // Constructor
  AStack(int size)
  {
    maxSize = size;
    topIndex = 0;
    listArray = new E[size];
  }

  // Destructor
  ~AStack()
  {
    delete[] listArray;
  }

  // Reinitialize
  void clear()
  {
    topIndex = 0;
  }

  // Put "it" on stack
  void push(const E& it)
  {
    listArray[topIndex++] = it;
  }

  // Pop top element
  E pop()
  {
    return listArray[--topIndex];
  }

  // Return top element
  const E& peek() const
  {
    return listArray[topIndex-1];
  }

  // Return length
  int length() const
  {
    return topIndex;
  }
};

template <typename T>
std::ostream& operator<< (std::ostream& out, const AStack<T>& stk)
{
  out << "[ ";
  for (int i=0; i < stk.length(); i++){
    out << stk.listArray[i] << ", ";
  }
  out << "]";
  return out;
}
